#include <iostream>

using namespace std;
class Elem
{
private:
    int val;
public:
    Elem* next;
    Elem(int val)
    {
        this->val=val;
    }
    int getVal()
    {
        return val;
    }
};
class Fifo
{
public:
    Elem* start=NULL;
    Elem* stop=NULL;
    void addElem(int val)
    {
        Elem *tmp=new Elem(val);
        if (stop==NULL)
        {
            stop=tmp;
            start=tmp;
        }
        else
        {
            stop->next=tmp;
            stop=tmp;
        }
    }
    int getElem()
    {

        int tmp=start->getVal();
        Elem * trash=start;
        start=start->next;
        delete trash;
        return tmp;
    }
};

class Lifo
{
private:
    Elem* start;
public:
    void addElem(int val)
    {
        Elem *tmp=new Elem(val);
        tmp->next=start;
        start=tmp;
    }
    int getElem()
    {
        int tmp=start->getVal();
        Elem* trash=start;
        start=start->next;
        delete trash;
        return tmp;
    }
};
int main()
{
    Lifo * myLifo=new Lifo;
    myLifo->addElem(5);
    myLifo->addElem(8);
    myLifo->addElem(2);
    myLifo->addElem(1);
    myLifo->addElem(2);
    myLifo->addElem(3);
    cout<< myLifo->getElem()<<endl;
    cout<< myLifo->getElem()<<endl;
    cout<< myLifo->getElem()<<endl;
    cout<< myLifo->getElem()<<endl;
    cout<< myLifo->getElem()<<endl;
    cout<< myLifo->getElem()<<endl;

    cout << "FIFO"<<endl;
    Fifo * myFifo=new Fifo();
    myFifo->addElem(5);
    myFifo->addElem(8);
    myFifo->addElem(2);
    cout<< myFifo->getElem()<<endl;
    cout<< myFifo->getElem()<<endl;
    myFifo->addElem(1);
    myFifo->addElem(2);
    myFifo->addElem(3);
    cout<< myFifo->getElem()<<endl;
    cout<< myFifo->getElem()<<endl;
    cout<< myFifo->getElem()<<endl;
    cout<< myFifo->getElem()<<endl;

    return 0;
}
